EffectLabelTextboxControl = class(Turbine.UI.Control)
function EffectLabelTextboxControl:Constructor(parent, width, y, args, number)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetMouseVisible(false)
    self:SetPosition(0, y)
    self:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)

    self.width = width
    self.number = number

    self.label = Turbine.UI.Label()
    self.label:SetParent(self)
    self.label:SetPosition(5, 0)
    self.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetOutlineColor(Turbine.UI.Color.Black)
    self.label:SetForeColor(Turbine.UI.Color.White)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.label:SetText(args.Text)

    self.textbox = Turbine.UI.Lotro.TextBox()
    self.textbox:SetParent(self)
    self.textbox:SetForeColor(Turbine.UI.Color.White)
    self.textbox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.textbox:SetText(args.Value and tostring(args.Value))

    self.textbox.TextChanged = function ()
        self:ValueChanged()
    end

    self.effectButton = UI.Button()
    self.effectButton:SetParent(self)
    self.effectButton:SetPosition(20, 23)
    self.effectButton:SetSize(200, 20)
    self.effectButton:SetText("Browse Effect Library")

    self.effectButton.MouseClick = function()
        if _G.EffectOverview then 
            _G.EffectOverview:SetVisible(not _G.EffectOverview:IsVisible())
        else
            _G.EffectOverview = Data.EffectOverview()
        end

        _G.EffectOverview:Register(self.textbox)
    end

    self:Format()
end

function EffectLabelTextboxControl:ValueChanged()

end

function EffectLabelTextboxControl:Format()
    self:SetSize(self.width, 45)
    self.label:SetSize(self.width * .3, 20)
    self.textbox:SetPosition(self.width * .3, 0)
    self.textbox:SetSize(self.width * .7, 20)
    self.effectButton:SetPosition(0, 23)
    self.effectButton:SetSize(200, 20)
end

function EffectLabelTextboxControl:GetValue()
    if self.number then
        return tonumber(tostring(self.textbox:GetText()))
    else
        return tostring(self.textbox:GetText())
    end
end

function EffectLabelTextboxControl:SetValue(value)
    self.textbox:SetText(tostring(value))
end